--  2006 Peter Thiemann
{- | Database query tracer. Facade for @Database.HDBC@
-}
module Database.TRANSDB.TraceQuery where

import qualified Database.HDBC as DB

type Connection = DB.Connection

logIt = 
  appendFile "/tmp/DEBUG"


prepare conn queryString =
  do logIt ("> prepare: " ++ queryString)
     r <- DB.prepare conn queryString
     logIt ("< prepare ")
     return r

sExecute st values =
  do logIt ("> sExecute " ++ show values)
     r <- DB.sExecute st values
     logIt ("< sExecute " ++ show r)
     return r

sFetchAllRows st =
  do logIt ("> sFetchAllRows")
     r <- DB.sFetchAllRows st
     logIt ("> sFetchAllRows " ++ show r)
     return r

sFetchRow st =
  do logIt ("> sFetchRow")
     r <- DB.sFetchRow st
     logIt ("< sFetchRow " ++ show r)
     return r

describeResult st =
  do --logIt ("> describeResult")
     r <- DB.describeResult st
     --logIt ("< describeResult " ++ show r)
     return r

commit conn =
  do logIt "> commit"
     r <- DB.commit conn
     logIt "< commit"
     return r

rollback conn =
  do logIt "> rollback"
     r <- DB.rollback conn
     logIt "< rollback"
     return r

handleSqlError io =
  do logIt "> handleSqlError"
     r <- DB.handleSqlError io
     logIt "< handleSqlError"
     return r
